MARKER unload-terminal

FALSE VALUE TermEcho?

#27 CONSTANT ExitChar


\ send data to terminal emulation
: ft-out ( cChar -- )
  DUP #32 < IF
    \ we have a control char
    CASE
      #13 OF #13 EMIT ENDOF
      #10 OF #10 EMIT ENDOF
      #11 OF CLR-EOL ENDOF
      #8  OF #8 EMIT ENDOF
      #2  OF COM2-IN COM2-IN SWAP AT-XY ENDOF
\      #14 OF vt-insln ENDOF
\      #15 OF vt-delln ENDOF
      #16 OF PAGE ENDOF
      #17 OF TRUE CURSOR ENDOF
      #18 OF FALSE CURSOR ENDOF
      #19 OF #19 COM2-OUT XY SWAP COM2-OUT COM2-OUT ENDOF
      #20 OF #20 COM2-OUT MAX-XY SWAP COM2-OUT COM2-OUT ENDOF
\      #21 OF 1 vt-color ENDOF
\      #22 OF 0 vt-color ENDOF     
    ENDCASE
  ELSE
    EMIT
  THEN ;

\ connect to a tcp server
\ use doSetIp to set server address, set VALUE destport to server port
: doTerm ( -- )
  ." connected. Press ESC to exit" CR
  EMPTY-KEYS  
  BEGIN
    TRUE
  WHILE
    COM2-IN? EMIT? AND IF COM2-IN ft-out THEN
    KEY? COM2-OUT? AND IF
      \ if key = ExitChar exit terminal
      KEY DUP ExitChar = IF
        DROP
        EXIT
      ELSE
        TermEcho? IF DUP EMIT THEN COM2-OUT
      THEN   
    THEN
  REPEAT
  CR ." connection closed " CR ;


\ set local echo option then launch terminal
: doTerm ( fLocalEcho -- )
  TO TermEcho?
  doTerm ;
     