MARKER forget-spinled

2VARIABLE led_mask

: init-led-mask ( uPinNum -- ) 
  1. ROT DLSHIFT
  led_mask 2! ; 


: dinvert ( d -- d' )
  $FFFFFFFF. DXOR ;

: set-bit ( d -- d' ) 
  led_mask 2@ DOR ;

: clr-bit ( d -- d' )
  led_mask 2@ dinvert DAND ;


: outa-bit ( fState  )
  $1F4 COG@ ROT IF
    set-bit
  ELSE
    clr-bit
  THEN
  $1F4 COG! ;

: dira-bit ( fState  )
  $1F6 COG@ ROT IF
    set-bit
  ELSE
    clr-bit
  THEN
  $1F6 COG! ;


: set-led ( f -- )
    outa-bit ;
  

: flash-led ( -- )
  0 init-led-mask
  TRUE dira-bit
  BEGIN 
    KEY? 0= 
  WHILE 
    TRUE set-led 
    #1000 MS 
    FALSE set-led 
    #600 MS
  REPEAT 
  FALSE outa-bit
  KEY DROP ;
