\ Web demo cgi functions for tool functions
\ this code is dynamicaly loaded by the WebDemo code.


\ List specified block contents
: WEX-LIST S" page=" web-valnum IF
    D>S DUP 0 blk-count WITHIN IF
      ( uBlockNum )
      \ see if block number holds password database, only admin can view page
      DUP pwd_blk <> 
      ( uBlockNum fNotPasswords )
      web_auth #99 =
      ( uBlockNum fNotPasswords fIsAdmin )
      0 rsp-text
      OR IF
        ( uBlockNum )
        LIST
      ELSE
        DROP
        ." Only admin my view user info page." CR
      THEN  
    ELSE
      0 rsp-text
      ." Page index must be a number from 0 to " blk-count 1- . CR
    THEN
  ELSE
    0 rsp-text
    ." Page index is not a number " CR
  THEN ;

\ Display contents of a range of memory, requires Tools.forth
: WEX-DUMP
  S" adr=" web-valnum IF
    D>S
    S" bytes=" web-valnum IF
      0 rsp-text
      D>S DUMP
    ELSE
      DROP
      0 rsp-text
      ." Invalid byte count " CR
    THEN
  ELSE
    0 rsp-text
    ." Invalid address " CR
  THEN ;

\ Display forth words, requires Tools.forth
: WEX-WORDS
  S" doit=" web-valstr IF
    ( c-adrWord uLenWord )
    DROP S" SEE" S= 0= IF
      S" word=" web-valstr IF
        ( we have a word to SEE, is the word valid )
        ( c-adrWord uLenWord )
        2DUP PAD >COUNTED
        PAD FIND IF
          DROP
          ( c-adrWord uLenWord )
          S" SEE " PAD >COUNTED
          ( copy word name string to buffer )
          ( c-adrWord uLenWord )
          PAD COUNT + SWAP DUP >R
          ( c-adrWord c-adrP uLenWord ) ( R: uLenWord )
          CMOVE
          ( update total string size )
          PAD C@ R> + PAD C!
          ( indicate a text responce )
          0 rsp-text 
          ( execute SEE command )
          PAD COUNT EVALUATE
        ELSE
          DROP
          2DROP
          0 rsp-text
          ." Specified word not found!  " CR
        THEN
      ELSE
        0 rsp-text
        ." No word specified!  " CR
      THEN
    ELSE
      0 rsp-text 
      S" Executing WORDS" debug-writeln
      WORDS
      S" WORDS DONE" debug-writeln
    THEN
  ELSE
    0 rsp-text 
    WORDS
  THEN ;


\ set date and time from post request params
: WEX-SETDATETIME ( -- )
  FALSE
  S" second=" web-valnum IF
    D>S
    ( fDateTimeSet uSecond )
    S" minute=" web-valnum IF
      ( fDateTimeSet uSecond uMinute )
      D>S
      S" hour=" web-valnum IF
        D>S
        ( fDateTimeSet uSecond uMinute uHour )
         S" day=" web-valnum IF
           D>S
           ( fDateTimeSet uSecond uMinute uHour uDay )
           S" month=" web-valnum IF
             ( fDateTimeSet uSecond uMinute uHour uDay uMonth )
             D>S
             S" year=" web-valnum IF
               D>S
               ( fDateTimeSet uSecond uMinute uHour uDay uMonth uYear )
               TIME&DATE!
               ( fDateTimeSet )
               DROP TRUE
             ELSE
               DROP 2DROP 2DROP  
             THEN
           ELSE
             2DROP 2DROP  
           THEN
         ELSE
           DROP 2DROP  
         THEN
      ELSE
        2DROP     
      THEN
    ELSE
      DROP  
    THEN
  THEN
  \ if we failed show error, else redisplay date/time page
  IF 
    rsp-redir
    ." Location: DATE" CR
  ELSE           
    0 rsp-text
    ." One or more parameters are missing!  " CR
  THEN ;
    
