\ Example of the use of DOES> forth word
\ Creates an array of fixxed length strings for
\ days of the week and months.

\ Create and array of fixxed length strings
\ The length of a sting element is passed as a parameter
: "ARRAY   ( compile: string-length -- ) ( run: -- a n )
   CREATE ( -- )
   \ Create a new dictionary entry
   ( string-length )
   \ save string length as first data char
   C,  
   \ Read the next token delimeted by a double quote char
   [CHAR] " WORD
   ( adrWord )
   \ Convert to adr and count  
   COUNT
   ( adrChars uCount )
   \ save string element char count to stack 
   >R 
   ( adrChars   R: uCount )
   \ copy the token to the dictionary 
   HERE R@ MOVE
   \ allocate storage space 
   R> ALLOT
   ( )
   DOES>
     ( uStrIdx adrData )   
     COUNT
     ( uStrIdx adrData1 uStrCount )   
     >R 
     ( uStrIdx adrData1  R: uStrCount )   
     SWAP 
     ( adrData1 uStrIdx  R: uStrCount )   
     R@ 
     ( adrData1 uStrIdx uStrCount  R: uStrCount )   
     * +
     ( adrStr  R: uStrCount )   
     R> ;

\ create an array for the months of the year, each element is 3 chars
#3 "ARRAY "MONTH "JanFebMarAprMayJunJulAugSepOctNovDec"

\ create an array for the days of the week, each element is 3 chars
#3 "ARRAY "DAY "SunMonTueWedThuFriSat"

