0 CONSTANT led_pin

: led-enable ( -- )
  led_pin dira-setpin ;

: led-disable ( -- )
  led_pin dira-clrpin ;

: led-on ( -- )
  led_pin outa-setpin ;

: led-off ( -- )
  led_pin outa-clrpin ;
  
\ flash the led the specified number of times
: led-flash ( uCount -- )
  \ activate pin connected to led as an output
  led-enable
  \ loop for the number of flashes requested
  0 ?DO
    \ trun on led
    led-on
    \ delay for 600 milli-seconds
    #600 MS
    \ trun off the led
    led-off
    \ delay for 600 milli-seconds
    #600 MS
  LOOP
  \ all done set led pin to input  
  led-disable ;
  
\ wait for a space key or an ESC key
\ return TRUE if was ESC key  
: wait-key ( -- fAbort )
  BEGIN 
    KEY? DUP IF
      ( fTrue ) 
      KEY DUP BL = IF
        ( fTrue cKey )
        DROP FALSE SWAP
        ( fFalse fTrue )
      ELSE  
        ( fTrue cKey )
        #27 = DUP IF
          ( fTrue fTrue )
        ELSE
          ( fTrue fFalse )
          NIP  
        THEN
      THEN    
    THEN
  UNTIL ;
    
    
: stop-watch
  CR
  BEGIN
    ." Press space bar to start timer, ESC to exit." CR
    BEGIN 
      wait-key IF
        EXIT
      THEN
      TRUE  
    UNTIL
    clr-time   
    ." Press space bar to stop timer." CR
    BEGIN 
      KEY? IF KEY BL = ELSE FALSE THEN
    UNTIL
    time. CR CR
  AGAIN ;
  
     