\ time a short runnung function ( < 24 sec), returns mill-seconds
\ Syntax: time-ex name (where name is forth word to time).
\ Params for forth word must be stacked before call to time-ex.
\
: time-ex ( -- )
  \ read name of forth word and find code address if in dictionary
  '
  ( adrForthWord )
  \ (tick) did not abort, forth word exists
  \ load 32 bit propeller chip system counter and save to return stack 
  COG-CNT 2>R
  ( adrForthWord  R: dSysCount )
  \ execute foth word
  EXECUTE
  ( R: dSysCount )
  \ forth word completed, read system counter again
  COG-CNT
  \ get start count from return stack  
  2R> 
  ( dSysCount dSysCount2 )
  D-
  ( dCountDelta )
  \ we have number of system ticks, convert to msec
  CLKFREQ 1000. D/ D/ UD. 
  ." ms" CR ; 
  