( Draw LED Numerics )

MARKER test

#124 CONSTANT led_vchar 
$5F CONSTANT led_hchar
#2 CONSTANT led_hcnt 
$2A CONSTANT led_colon
#2 VALUE led_vcnt

VARIABLE led_f $77 C, $24 C, $5D C, $6D C, $2E C, $6B C, $7B C,
 $25 C, $7F C, $2F C, ALIGN 
 
: led-pat ( cDigit -- uLedBits )
  led_f #2 + + C@ ;
 
: XY+ ( Col Row C+ R+ - col row ) 
  >R ROT + SWAP R> + ;
  
: led-hbar
  led_hchar led_hcnt 0 DO
    DUP EMIT
  LOOP
  DROP ;
  
: led-hclr
  led_hcnt SPACES ;
  
: led-vbar
  led_vchar led_vcnt 0 DO DUP EMIT XY
  -1 1 XY+ AT-XY LOOP DROP ;
 
: led-vclr
  led_vcnt 0 DO
    SPACE XY -1 1 XY+ AT-XY
  LOOP ;
  
: led-hdraw ( flag - )
  IF 
    led-hbar
  ELSE
    led-hclr
  THEN ;
  
: led-vdraw ( flag - )
  IF
    led-vbar
  ELSE
    led-vclr
  THEN ;
  
: led-cdraw ( flag - )
  XY led_hcnt 2 + led_vcnt XY+ AT-XY
  IF
    led_colon
  ELSE
    $20
  THEN
  DUP EMIT XY
  -1 1 XY+ AT-XY EMIT ;
  
: led-nxtbit ( bits - bits2 flag )
  1 RSHIFT DUP 1 AND 1 = ;
  
: led-draw ( bits - )
  XY 2>R
  DUP 1 AND 1 = 2R@ 1 0 XY+ AT-XY led-hdraw
  led-nxtbit 2R@ 0 1 XY+ AT-XY led-vdraw
  led-nxtbit 2R@ led_hcnt 1+ 1 XY+ AT-XY led-vdraw
  led-nxtbit 2R@ 1 led_vcnt XY+ AT-XY led-hdraw
  led-nxtbit 2R@ 0 led_vcnt 1+ XY+ AT-XY led-vdraw
  led-nxtbit 2R@ led_hcnt 1+ led_vcnt 1+ XY+ AT-XY
  led-vdraw led-nxtbit 2R@ 1 led_vcnt 2* XY+
  AT-XY led-hdraw led-nxtbit 2R@ AT-XY led-cdraw DROP
  2R> led_hcnt 3 + 0 XY+ AT-XY ;
  
\ display a 2 digit decimal byte (0..99)  
: led-. ( fColon cByte - )
  #10 /MOD
  ( fColon cHigh cLow )
  led-pat led-draw
  ( fColon cLow )
  led-pat SWAP 
  ( uDigitBits fColon )
  IF 
    ( uDigitBits )
    $80 OR 
  THEN
  ( uDigitBits )
  led-draw ;
   
: led-hms. ( uSec uMin uHr - )
  #2 TO led_vcnt TRUE SWAP led-. TRUE SWAP led-.
  1 TO led_vcnt FALSE SWAP led-. ;
  
: led-time ( uSec uMin uHr - ) 1 1 AT-XY led-hms. ;

2VARIABLE vt_time

: vt-time 
  FALSE CURSOR PAGE
  TIME DROP vt_time 2!
  BEGIN 
    TIME >R 2DUP
    vt_time 2@ D= IF
      2DROP RDROP
    ELSE
      2DUP vt_time 2!
      R>
      led-time    
    THEN
    KEY?
  UNTIL 
  TRUE CURSOR
  PAGE ;

